Create ledger entry
This endpoint allows you to create a new ledger entry for a specified customer’s balance. This can be used to increment balance, deduct credits, and change the expiry date of existing credits.
Effects of adding a ledger entry
- After calling this endpoint, Fetch Credit Balance will return a credit block that represents the changes (i.e. balance changes or transfers).
- A ledger entry will be added to the credits ledger for this customer, and therefore returned in the View Credits Ledger response as well as serialized in the response to this request. In the case of deductions without a specified block, multiple ledger entries may be created if the deduction spans credit blocks.
- If
invoice_settingsis specified, an invoice will be created that reflects the cost of the credits (based onamountandper_unit_cost_basis).
Adding credits
Adding credits is done by creating an entry of type increment. This requires the caller to specify a number of
credits as well as an optional expiry date in YYYY-MM-DD format. Orb also recommends specifying a description
to assist with auditing. When adding credits, the caller can also specify a cost basis per-credit, to indicate
how much in USD a customer paid for a single credit in a block. This can later be used for revenue recognition.
The following snippet illustrates a sample request body to increment credits which will expire in January of 2022.
{
"entry_type": "increment",
"amount": 100,
"expiry_date": "2022-12-28",
"per_unit_cost_basis": "0.20",
"description": "Purchased 100 credits"
}
Note that an increment entry always creates a new credit block (defined by the optional effective_date and
expiry_date); it never modifies an existing block.
Invoicing for credits
By default, Orb manipulates the credit ledger but does not charge for credits. However, if you pass
invoice_settings in the body of this request, Orb will also generate a one-off invoice for the customer for the
credits pre-purchase. Note that you must provide the per_unit_cost_basis, since the total charges on the
invoice are calculated by multiplying the cost basis with the number of credit units added. If you invoice or handle payment
of credits outside of Orb (i.e. marketplace customers), set mark_as_paid in the invoice_settings to true to prevent
duplicate invoicing effects.
- if
per_unit_cost_basisis greater than zero, an invoice will be generated andinvoice_settingsmust be included - if
invoice_settingsis passed, one of eithercustom_due_dateornet_termsis required to determine the due date
Deducting Credits
Orb allows you to deduct credits from a customer by creating an entry of type decrement. A decrement entry
records credits as usage and immediately recognizes revenue at the block’s per_unit_cost_basis.
For most credit removals, use void (no revenue impact) or expiration_change (revenue recognized on expiration)
instead. Only use decrement when credits were genuinely consumed outside of normal event ingestion.
Orb matches the algorithm for automatic deductions for determining which credit blocks to decrement from. In the case that the deduction leads to multiple ledger entries, the response from this endpoint will be the final deduction. Orb also optionally allows specifying a description to assist with auditing.
The following snippet illustrates a sample request body to decrement credits.
{
"entry_type": "decrement",
"amount": 20,
"description": "Removing excess credits"
}
Changing credits expiry
If you’d like to change when existing credits expire, you should create a ledger entry of type expiration_change.
For this entry, the required parameter expiry_date identifies the originating block, and the required parameter
target_expiry_date identifies when the transferred credits should now expire. A new credit block will be created
with expiry date target_expiry_date, with the same cost basis data as the original credit block, if present.
Note that the balance of the block with the given expiry_date must be at least equal to the desired transfer
amount determined by the amount parameter.
The following snippet illustrates a sample request body to extend the expiration date of credits by one year:
{
"entry_type": "expiration_change",
"amount": 10,
"expiry_date": "2022-12-28",
"block_id": "UiUhFWeLHPrBY4Ad",
"target_expiry_date": "2023-12-28",
"description": "Extending credit validity"
}
Voiding credits
If you’d like to void a credit block, create a ledger entry of type void. For this entry, block_id is required
to identify the block, and amount indicates how many credits to void, up to the block’s initial balance. Pass
in a void_reason of refund if the void is due to a refund.
Amendment
If you’d like to undo a decrement on a credit block, create a ledger entry of type amendment. For this entry, block_id
is required to identify the block that was originally decremented from, and amount indicates how many credits to return
to the customer, up to the block’s initial balance.
Authorizations
API Keys can be issued in the Orb's web application.
Path Parameters
Body
- AddIncrementCreditLedgerEntryRequestParams
- AddDecrementCreditLedgerEntryRequestParams
- AddExpirationChangeCreditLedgerEntryRequestParams
- AddVoidCreditLedgerEntryRequestParams
- AddAmendmentCreditLedgerEntryRequestParams
increment The number of credits to effect. Note that this is required for increment, decrement, void, or undo operations.
User-specified key/value pairs for the resource. Individual keys can be removed by setting the value to null, and the entire metadata mapping can be cleared by setting metadata to null.
The currency or custom pricing unit to use for this ledger entry. If this is a real-world currency, it must match the customer's invoicing currency.
Optional metadata that can be specified when adding ledger results via the API. For example, this can be used to note an increment refers to trial credits, or for noting corrections as a result of an incident, etc.
An ISO 8601 format date that denotes when this credit balance should expire.
An ISO 8601 format date that denotes when this credit balance should become available for use.
Can only be specified when entry_type=increment. How much, in the customer's currency, a customer paid for a single credit in this block
Passing invoice_settings automatically generates an invoice for the newly added credits. If invoice_settings is passed, you must specify per_unit_cost_basis, as the calculation of the invoice total is done on that basis.
Optional filter to specify which items this credit block applies to. If not specified, the block will apply to all items for the pricing unit.
Response
Created
- IncrementLedgerEntry
- DecrementLedgerEntry
- ExpirationChangeLedgerEntry
- CreditBlockExpiryLedgerEntry
- VoidLedgerEntry
- VoidInitiatedLedgerEntry
- AmendmentLedgerEntry
The Credit Ledger Entry resource models prepaid credits within Orb.
User specified key-value pairs for the resource. If not present, this defaults to an empty dictionary. Individual keys can be removed by setting the value to null, and the entire metadata mapping can be cleared by setting metadata to null.
committed, pending increment If the increment resulted in invoice creation, the list of created invoices